## calcoffset.cl
##

procedure calcoffset (imglist,offsetdata,xcenter,ycenter)

file imglist      {prompt = "Input image list with @mark"}
file offsetdata   {prompt = "Output offset data name"}
real xcenter      {prompt = "The origin of the x coordinate"}
real ycenter	  {prompt = "The origin of the y coordinate"}
#
begin

	string imglst,offsetdat
	string tmpfile1,tmpfile2,tmpfile3
	char fname1
	real x0,y0
	real x,y,a,b
	real dx,dy

	imglst = imglist
	offsetdat = offsetdata
	x0 = xcenter
	y0 = ycenter

	if(access(offsetdat)) {
		del(offsetdat)
	}

	print ("# The origin of offset = [", x0, ",",  y0, "]", >> offsetdat)

	tmpfile1 = mktemp("tmp_file.")
	sections (imglst,option='fullname',> tmpfile1)

	list = tmpfile1

	while (fscan(list,fname1) == 1) {
		print("\nSelsct Object --> type a  , Quit --> type q")
		print("Caution : You must not type any key except a or q\n")
		
		tmpfile2 = mktemp("tmp_file.")
		tmpfile3 = mktemp("tmp_file.")

		imexam(fname1, > tmpfile2)
		type(tmpfile2)
		tail (tmpfile2,nl=2,> tmpfile3)
		head (tmpfile3,nl=1) | scanf ("%f %f %f %f",x,y,a,b)

		dx = x0 - x
		dy = y0 - y

		print (dx,dy,>>offsetdat)

		del (tmpfile2,ver-,>&"dev$null")
		del (tmpfile3,ver-,>&"dev$null")
	}

	del (tmpfile1,ver-,>&"dev$null")

end
