procedure eraseobj (inlist,masklist,outlist)

file inlist   {prompt = "Input file list name with @mark"}
file masklist {prompt = "Mask coordinate data file list with @mark"}
file outlist  {prompt = "Output file list name with @mark"} 
real  minsize {1,prompt = "Minimum mask aperute size"}

struct  *list1 {mode = 'h'}
struct  *list2 {mode = 'h'}
struct  *list3 {mode = 'h'}
struct  *list4 {mode = 'h'}
#
#
begin
	string tmp_infile,tmp_outfile,tmp_maskfile,tmpfile4,tmpfile5
	string tmpimage1,tmpimage2,tmpimage3,tmpimage4,tmpimage5,tmpimage6,tmpimage7,tmpimage8,tmpimage9
	string fname1,fname2,fname3

	real min
	real xx,yy,r,r0

	min = minsize

	tmp_infile = mktemp("tmp_file.")
	tmp_outfile = mktemp("tmp_file.")
	tmp_maskfile = mktemp("tmp_file.")
	sections(inlist,option='fullname', > tmp_infile)
	sections(outlist,option='fullname', > tmp_outfile)
	sections(masklist,option='fullname', > tmp_maskfile)

	list1 = tmp_infile
	list2 = tmp_outfile
	list3 = tmp_maskfile

	while(fscan(list1,fname1) == 1){
		if (fscan(list2,fname2) == 1) {
			if(fscan(list3,fname3) == 1) {
				tmpimage1 = mktemp("tmp_img.")
				tmpimage2 = mktemp("tmp_img.")
#				tmpimage3 = mktemp("tmp_img.")
#				tmpimage4 = mktemp("tmp_img.")
#				tmpimage5 = mktemp("tmp_img.")
#				tmpimage6 = mktemp("tmp_img.")
				tmpimage7 = mktemp("tmp_img.")
				tmpimage8 = mktemp("tmp_img.")
				tmpimage9 = mktemp("tmp_img.")

				median(fname1,tmpimage1,5,5,ver-)
				
				list4 = fname3
				tmpfile4 = mktemp("tmp_file.")
				i = 0
				r0 = 0
				while(fscan(list4,xx,yy,r) == 3){
					if(r >= min){
						if (i != 0 && r != r0){
							#print ("Radius = ",r0," , num = ",i)
							imedit (tmpimage1, tmpimage2, cursor=tmpfile4, display-, radius=r0, search=0, buffer=20, width=20)
							imdel (tmpimage1)
							imedit (tmpimage2, tmpimage1, cursor=tmpfile4, display-, radius=r0, search=0, buffer=20, width=20)
							imdel (tmpimage2)
							del (tmpfile4,ver-,>&"dev$null")
							tmpfile4 = mktemp("tmp_file.")
						}
						print (xx,yy,>> tmpfile4)
						r0 = r
						i += 1
					}
				}

#				print ("Radius = ",r0," , num = ",i)
				imedit (tmpimage1, tmpimage2, cursor=tmpfile4, display-, radius=r0, search=0, buffer=20, width=20)
				imdel (tmpimage1)
				imedit (tmpimage2, tmpimage1, cursor=tmpfile4, display-, radius=r0, search=0, buffer=20, width=20)
				imdel (tmpimage2)
				del (tmpfile4,ver-,>&"dev$null")
				
#				blkavg(tmpimage1//"[*,51:974]",tmpimage3,1,2000)
#				magnify(tmpimage3,tmpimage4,1.,0.0009765625, y2=1024, dy=1, interpo='nearest', boundar='nearest', fluxcon-)
#				imarith (tmpimage1, "-", tmpimage4, tmpimage5)
#				imsurfit (tmpimage5, tmpimage6, 10, 10, xmedian=5, ymedian=5, type_ou='fit')
#				imarith (tmpimage4, "+", tmpimage6, tmpimage7)
				imsurfit (tmpimage1, tmpimage7, 10, 10, xmedian=5, ymedian=5, type_ou='fit')
				imarith (fname1, "-", tmpimage7, tmpimage8)

				list4 = fname3
				tmpfile5 = mktemp("tmp_file.")
				i = 0
				r0 = 0
				while(fscan(list4,xx,yy,r) == 3){
					if(r >= min){
						if (i != 0 && r != r0) {	
							imedit (tmpimage8, tmpimage9, cursor=tmpfile5, display-, radius=r0, search=0, buffer=20, width=20)
							imdel (tmpimage8)
							imedit (tmpimage9, tmpimage8, cursor=tmpfile5, display-, radius=r0, search=0, buffer=20, width=20)
							imdel (tmpimage9)
							del (tmpfile5,ver-,>&"dev$null")
							tmpfile5 = mktemp("tmp_file.")
						}
						print (xx,yy,>> tmpfile5)
						r0 = r
						i += 1
					}
				}
				
				#print ("Radius = ",r0," , num = ",i)
				imedit (tmpimage8, tmpimage9, cursor=tmpfile5, display-, radius=r0, search=0, buffer=20, width=20)
				imdel (tmpimage8)
				imedit (tmpimage9, tmpimage8, cursor=tmpfile5, display-, radius=r0, search=0, buffer=20, width=20)
				imdel (tmpimage9)
				del (tmpfile5,ver-,>&"dev$null")

				imarith (tmpimage8, "+", tmpimage7, fname2)
				
#				display(fname2,1,fi+,zs+,zr+)
				
				imdel (tmpimage1)
#				imdel (tmpimage3)
#				imdel (tmpimage4)
#				imdel (tmpimage5)
#				imdel (tmpimage6)
				imdel (tmpimage7)
				imdel (tmpimage8)
						
			}
		}
	}

	del (tmp_infile,ver-,>&"dev$null")
	del (tmp_outfile,ver-,>&"dev$null")
	del (tmp_maskfile,ver-,>&"dev$null")

end

