#####################################
# IRCS bad frame checker (06/28/08) #
#####################################

procedure frcheck(filelist)
	file  filelist {prompt = 'List of files to be checked without @ mark'}
	bool  mklist    {"no",prompt = 'Make bad frame excluded list?'}
	char  calc      {"subtract",prompt = 'Calcuration (subtract/divide)',enum="subtract|divide"}

begin
	char _filelist
        char _calc
	char tmplist1, tmplist2
	int i
	int len, idx
	char fits_pre, fits_cur
	char prefix_pre, prefix_cur
        char fits_check
	char fname
	char mark

	_filelist = filelist
	_calc = calc

	if(access(_filelist//"-b")){
	  print("Operation would overwrite "//_filelist//"-b")          
        }else{
          list = _filelist

       	  tmplist1 = mktemp("tmp_file.")
	  tmplist2 = mktemp("tmp_file.")
          cp(_filelist,tmplist1)

	  i = 0

          print("## Making check images")
	  while (fscan(list,line) != EOF) {
	    if(i==0){
              fits_pre = line
              len = strlen(fits_pre)
              idx = stridx("/",fits_pre)
              prefix_pre  = substr(fits_pre,idx+1,len)
              idx = stridx(".",prefix_pre)
              prefix_pre  = substr(prefix_pre,1,idx-1)
	    }else{
              fits_cur = line
              len = strlen(fits_cur)
              idx = stridx("/",fits_cur)
              prefix_cur  = substr(fits_cur,idx+1,len)
              idx = stridx(".",prefix_cur)
              prefix_cur  = substr(prefix_cur,1,idx-1)
              fits_check = prefix_pre//"-"//prefix_cur//".fits"
	      if(_calc == "subtract"){
                imarith(fits_pre,"-",fits_cur,fits_check,ver-)
              }else{
                imarith(fits_pre,"/",fits_cur,fits_check,ver-)
              }
              print(fits_check,>>tmplist2)
	      fits_pre = fits_cur
	      prefix_pre = prefix_cur
	    }
            i += 1
          }
          print("## Done")

          print("## Check images on ds9")
	  imexam("@"//tmplist2,1)

	  if(mklist) {
	    vi(tmplist1)
	    list = tmplist1
	    while (fscan (list,fname) != EOF) {
               print (fname, >> _filelist//"-b")
            }
	  }

	  imdelete("@"//tmplist2,yes,ver-)
	  delete(tmplist1,yes,ver-)
	  delete(tmplist1//"~",yes,ver-)
	  delete(tmplist2,yes,ver-)
       }
end


